/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef BONUS_H
#define BONUS_H

#include "gameobject.h"
#include "player.h"

#include "../modelloader.h"

/** Bonus object
 * 
 */
class Bonus : public GameObject {
public:
    Bonus();

    /**
     * applies bonus to player
     * @param pl
     */
    virtual void apply(Player* pl);
    virtual void update(int elapsed);

    bool isExpired() {
        return expire <= 0;
    }

    Player* getOwner();

protected:
    int expire;
    Player* owner;

    void createCircle();
};

/** 
 * Bonus -- healing
 */
class BonusHeal : public Bonus {
public:
    BonusHeal();
    virtual void apply(Player* pl);
    virtual void update(int elapsed);
};

/**
 * Bonus -- ammo
 */
class BonusAmmo : public Bonus {
public:
    BonusAmmo();
    virtual void apply(Player* pl);
    virtual void update(int elapsed);
};

/**
 * Bonus -- laser
 */
class BonusLaser : public Bonus {
public:
    BonusLaser();
    virtual void apply(Player* pl);
    virtual void update(int elapsed);
};

#endif // BONUS_H
