/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#ifndef CONTROLS_H
#define CONTROLS_H

#define MAX_PLAYERS 4

#include <QObject>
#include <QMap>
#include <QKeyEvent>
#include <QApplication>

#include <iostream>

/**
 * Class that handles player controls
 */
class Controls : public QObject {
    Q_OBJECT
public:
    // singleton instance
    static Controls* instance();

    // testing flags

    bool isRight(int i) {
        return right[i];
    }

    bool isLeft(int i) {
        return left[i];
    }

    bool isUp(int i) {
        return up[i];
    }

    bool isDown(int i) {
        return down[i];
    }

    bool isShoot(int i) {
        return shoot[i];
    }

    bool isCamZoom() {
        return camZoom;
    }

    bool isCamUnzoom() {
        return camUnzoom;
    }

    bool isCamSwitch() {
        bool temp = camSwitch;
        camSwitch = false;
        return temp;
    }

    // event handling
    bool press(int key);
    bool release(int key);

private:
    explicit Controls(QObject *parent = 0);
    static Controls* pinstance;
    QMap<int, bool*> binds;

    bool right[MAX_PLAYERS + 1];
    bool left[MAX_PLAYERS + 1];
    bool up[MAX_PLAYERS + 1];
    bool down[MAX_PLAYERS + 1];
    bool shoot[MAX_PLAYERS + 1];
    bool camZoom, camUnzoom, camUp, camDown, camSwitch;

signals:
    void cheat1();
    void cheat2();
    void cheat3();
    void cheat4();
};

#endif // CONTROLS_H
