/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#include "gamecamera.h"

GameCamera::GameCamera(osg::Camera* cam) {
    followObject = NULL;
    mode = FOCUS;
    camera = cam;
    distance = 400;
    angle = -25;
    osg::Vec3 f(0, -30, 0);
    focusAt(f);

    update();
}

void GameCamera::focusAt(osg::Vec3 center) {
    focus = center;
}

void GameCamera::focusMove(osg::Vec3 add) {
    focus += add;
}

void GameCamera::zoom(int z) {
    distance += z;
}

void GameCamera::switchMode() {
    if (mode == FOLLOW)mode = FOCUS;
    else if (mode == FOCUS)mode = FOLLOW;
}

osg::Vec3 GameCamera::getEye() {
    double rad = osg::DegreesToRadians(angle);
    return osg::Vec3(0 + focus.x(), distance * sin(rad) + focus.y(), distance * cos(rad));
}

void GameCamera::update() {
    if (mode == FOLLOW && followObject != NULL) {
        focus = followObject->getPosition();
    }
    osg::Vec3 up(0, 0, 1);
    camera->setViewMatrixAsLookAt(getEye(), focus, up);
}

