/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef GAMECAMERA_H
#define GAMECAMERA_H

#include <osg/Camera>
#include "gameobject.h"

/**
 * Class for handlign camera
 */
class GameCamera {
public:

    enum cameraMode { //camera modes
        FOLLOW = 0, FOCUS
    };
    GameCamera(osg::Camera* cam);

    // positioning

    void follow(GameObject* obj) {
        mode = FOLLOW;
        followObject = obj;
    }

    void focusAt(osg::Vec3 center);
    void focusMove(osg::Vec3 add);
    void zoom(int z);

    // getters

    osg::Vec3 getFocus() {
        return focus;
    }

    double getDistance() {
        return distance;
    }

    double getAngle() {
        return angle;
    }

    cameraMode getMode() {
        return mode;
    }
    osg::Vec3 getEye();
    //switchning came modes
    void switchMode();

    // update camera position
    void update();
private:
    osg::Camera* camera;
    GameObject* followObject;

    osg::Vec3 focus;
    double distance;
    double angle;
    cameraMode mode;
};

#endif // GAMECAMERA_H
