/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef GAMECONTROLCLIENT_H
#define GAMECONTROLCLIENT_H

#include "gamecontrol.h"
#include "../network/connection.h"
#include "../network/packet.h"

#include "../launcher.h"

/**
 * Extension of GameControl for client side of multiplayer game
 */
class GameControlClient : public GameControl {
public:
    GameControlClient(QObject * parebt = 0);
    virtual ~GameControlClient();

    virtual void init();
    virtual void start();

protected:
    int playerNumber;
    Connection* con;

    QTime pingTimer;
    int pingSeq;
    int ping;
    bool pong;



    // last confirmed position
    int lastX;
    int lastY;

    virtual void updatePlayers(int elapsed);
    virtual void updateBonuses(int elapsed);


    // packet handling
    virtual void readPackets();
    void packetPlayerPosition(PositionPacket *p);
    void spawn(PositionPacket* p);
    void packetShoot(IntPacket *p);
    void packetDisconnected(IntPacket *p);
    void packetKill(IntPacket *p);
    void packetDamage(IntPacket *p);
    void packetScore(ScorePacket *p);
    void packetPingReply(IntPacket *p);
    void packetBonusSpawn(BonusPacket *p);
    void packetBonusRemove(IntPacket *p);


    public
slots:
    virtual void gameLoop();
};

#endif // GAMECONTROLCLIENT_H
