/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef GAMECONTROLHOST_H
#define GAMECONTROLHOST_H
class GameControlHost;
#include "gamecontrol.h"
#include "../network/hostconnection.h"
#include "../network/packet.h"

/**
 * Extension of GameControl for Hosting Multiplayer game
 */
class GameControlHost : public GameControl {
public:
    GameControlHost(QObject *parent = 0);
    virtual ~GameControlHost();

    virtual void init();
    virtual void start();
protected:
    HostConnection* con;



    virtual void spawn(Player* p);
    virtual void updatePlayers(int elapsed);
    virtual void updateBonuses(int elapsed);
    virtual void updateCollisions(int elapsed);

    // packet handling
    virtual void readPackets();
    void packetPlayerPosition(PositionPacket *p);
    void packetWantShoot(IntPacket *p);
    void packetPing(IntPacket *p);


    public
slots:
    virtual void gameLoop();

};

#endif // GAMECONTROLHOST_H
