/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "gamecontrolwidget.h"

GameControlWidget::GameControlWidget(int type, QWidget *parent) :
GSWidget(parent) {
    std::cout << "GameControlWidget construtor\n";

    //printf("a\n");

    switch (type) {
        case SOLO:
        case HOTSEAT:
            //printf("b\n");
            gc = new GameControl(this);
            break;
        case HOST:
            //printf("c\n");
            gc = new GameControlHost(this);
            break;
        case CLIENT:
            //printf("d\n");
            gc = new GameControlClient(this);
            break;
    }
    //printf("a\n");
    gs = new GameScene(this);

    gc->setGameScene(gs);
    gc->init();

    //printf("a\n");
    scene = gs;
    gw->setScene(gs);
    gw->update();
    gw->show();

    //printf("a\n");
    setFocus();
    gc->start();
    std::cout << "GameControlWidget construtor end\n";

}

GameControlWidget::~GameControlWidget() {

}
