/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/


#ifndef GAMECONTROLWIDGET_H
#define GAMECONTROLWIDGET_H
class GameControlWidget;
#include <QWidget>
#include <QTimer>
#include <QVector>

#include <osg/Camera>
#include <osg/Group>

#include "gamecontrol.h"
#include "gamecontrolclient.h"
#include "gamecontrolhost.h"

#include "../gswidget.h"

enum gameType {
    SOLO, HOTSEAT, CLIENT, HOST
};

/**
 * Widget to display game
 */
class GameControlWidget : public GSWidget {
    Q_OBJECT
public:

    explicit GameControlWidget(int type, QWidget *parent = 0);
    virtual ~GameControlWidget();

    GameControl* gc;
    GameScene* gs;
protected:


    void keyPressEvent(QKeyEvent *evt) {
        if (evt->key() == Qt::Key_F2) {
            if (gs)gs->switchHUDVisible();
        } else
            evt->setAccepted(Controls::instance()->press(evt->key()));
    }

    void keyReleaseEvent(QKeyEvent *evt) {
        evt->setAccepted(Controls::instance()->release(evt->key()));
    }

    void focusOutEvent(QFocusEvent *) {
        setFocus();
    }

signals:

public slots:

};

#endif // GAMECONTROLWIDGET_H
