/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef GAMESCENE_H
#define GAMESCENE_H

#include "../qosgscene.h"
#include "../settings.h"
#include "playerportrait.h"

#include <osg/Geode>
#include <osg/Group>
#include <osg/ShapeDrawable>
#include <osg/LineWidth>
#include <osgDB/ReadFile>
#include <QLabel>
#include <QHBoxLayout>

/**
 * Class to wrap game HUD and 3D scene of game
 */
class GameScene : public QOSGScene {
    Q_OBJECT
public:
    explicit GameScene(QObject *parent = 0);
    virtual ~GameScene();

    // make and show grid
    void makeGrid();
    void setGridVisible(bool t);

    osg::Group* getOSGScene() {
        return scene;
    }

    PlayerPortrait* getPortrait(int i) {
        return portraits[i];
    }

    void switchHUDVisible();

    void addToHUD(QWidget *widget);

protected:
    bool visible;
    osg::ref_ptr<osg::Geode> grid;
    QLabel* portraitsLabel;
    PlayerPortrait* portraits[4];


    QVector<QWidget*> HUD;


signals:

public slots:
    void resized();

};

#endif // GAMESCENE_H
