/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "mapobject.h"

MapObject::MapObject() {
    mod = STILL;

    rotationSpeedSelf = 0;
    rotationSpeedObj = 0;
    rotationObj = 0;
    distance = 0;
    rotationObjPtr = NULL;
}

void MapObject::update(int elapsed) {
    GameObject::update(elapsed);
    double rad;
    switch (mod) {
        case ROTATING_OBJ:
            rad = osg::DegreesToRadians(rotationObj);
            setPosition(osg::Vec3(
                    rotationObjPtr->getX() + cos(rad) * distance,
                    rotationObjPtr->getY() + sin(rad) * distance,
                    0));
            rotationObj += rotationSpeedObj*elapsed;
        case ROTATING_SELF:
            rotateY(rotationSpeedSelf * elapsed);
        case STILL:
        default:
            break;

    };
}

Asteroid::Asteroid() {
    mod = ROTATING_SELF;
    rotationSpeedSelf = 0.05;
    collisionRadius = 12;
    model->addChild(ModelLoader::instance()->modelAsteroid.get());
}

AsteroidField::AsteroidField() {
    mod = ROTATING_SELF;
    rotationSpeedSelf = (rand() % 100 - 50) / 1000.0;
    collisionRadius = 8;
    model->addChild(ModelLoader::instance()->modelAsteroidField.get());
}

Planet::Planet() {
    mod = ROTATING_SELF;
    rotationSpeedSelf = -0.01;
    collisionRadius = 20;
    model->addChild(ModelLoader::instance()->modelPlanet.get());
}

Moon::Moon() {
    mod = ROTATING_OBJ;
    rotationSpeedSelf = -0.08;
    rotationSpeedObj = 0.01;
    distance = 60;
    collisionRadius = 6;
    model->addChild(ModelLoader::instance()->modelMoon.get());
}
