/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef MAPOBJECT_H
#define MAPOBJECT_H

#include "gameobject.h"

/**
 * Abstract class for Map Object, extends Game Object
 * 
 */
class MapObject : public GameObject {
public:

    // movement mode

    enum moveMode {
        STILL, ROTATING_SELF, ROTATING_OBJ
    };

    MapObject();

    void update(int elapsed);

    void setRotationObj(GameObject* o) {
        rotationObjPtr = o;
    }
protected:
    double rotationSpeedSelf;
    double rotationSpeedObj;
    double rotationObj;
    double distance;
    GameObject* rotationObjPtr;
    moveMode mod;
};

class Asteroid : public MapObject {
public:
    Asteroid();
};

class AsteroidField : public MapObject {
public:
    AsteroidField();
};

class Planet : public MapObject {
public:
    Planet();
};

class Moon : public MapObject {
public:
    Moon();
};
#endif // MAPOBJECT_H
