/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "maps.h"



Maps* Maps::pinstance = NULL;

Maps::Maps() {
    mapList = new QVector<Map*>;
    mapList->append(new Map);
    mapList->append(new Map1);
    mapList->append(new Map2);

    /*
      append custom maps from file

     */

}

Maps* Maps::instance() {
    if (pinstance == NULL) {
        pinstance = new Maps;
    }
    return pinstance;
}

Maps::~Maps() {
    while (!mapList->isEmpty()) {
        delete mapList->back();
        mapList->pop_back();
    }
    delete mapList;
    pinstance = NULL;
}

Map::Map() {
    name = Texts::get(QString("EMPTY_MAP"));
}

void Map::loadMap(GameControl *gc) {
    osg::PositionAttitudeTransform* scale = new osg::PositionAttitudeTransform;
    osg::Node* bg = ModelLoader::instance()->modelSpace2.get();
    scale->addChild(bg);
    scale->setScale(osg::Vec3(7.5, 7.5, 1.0));

    osg::PositionAttitudeTransform* tx = new osg::PositionAttitudeTransform;
    tx->addChild(scale);
    tx->setPosition(osg::Vec3(0, 250, -500));
    gc->getGameScene()->addModel(tx);
}

Map1::Map1() {
    name = Texts::get(QString("MAP1"));
}

void Map1::loadMap(GameControl *gc) {
    MapObject *obj, *obj2;
    obj = new Asteroid;
    obj->setPosition(osg::Vec3(50, 50, 0));
    gc->addMapObject(obj);

    obj = new Planet;
    obj->setPosition(osg::Vec3(-100, 20, 0));
    gc->addMapObject(obj);

    obj2 = new Moon;
    gc->addMapObject(obj2);
    obj2->setPosition(osg::Vec3(-100, 20, 0));
    obj2->setRotationObj(obj);
}

Map2::Map2() {
    name = Texts::get(QString("MAP2"));
}

void Map2::loadMap(GameControl *gc) {
    MapObject *obj;

    for (int i = 0; i < 7; i++) {
        obj = new AsteroidField;
        obj->setPosition(osg::Vec3(140 - 10 * i, 100 - 10 * i, 0));
        gc->addMapObject(obj);

        obj = new AsteroidField;
        obj->setPosition(osg::Vec3(-140 + 10 * i, 100 - 10 * i, 0));
        gc->addMapObject(obj);

        obj = new AsteroidField;
        obj->setPosition(osg::Vec3(-140 + 10 * i, -100 + 10 * i, 0));
        gc->addMapObject(obj);

        obj = new AsteroidField;
        obj->setPosition(osg::Vec3(140 - 10 * i, -100 + 10 * i, 0));
        gc->addMapObject(obj);

        obj = new AsteroidField;
        obj->setPosition(osg::Vec3(0, -100 + 10 * i, 0));
        gc->addMapObject(obj);

        obj = new AsteroidField;
        obj->setPosition(osg::Vec3(0, 100 - 10 * i, 0));
        gc->addMapObject(obj);
    }

}

