/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef MAPS_H
#define MAPS_H
class Map;
class Maps;

#include "gamecontrol.h"
#include "mapobject.h"
#include "../texts.h"
#include "../modelloader.h"

#include <QString>
#include <QVector>

/**
 * Maplist
 * @return 
 */
class Maps {
public:

    static Maps* instance();

    QVector<Map*>* getMapList() {
        return mapList;
    }
    virtual ~Maps();
private:
    Maps();

    static Maps *pinstance;
    QVector<Map*> *mapList;
};

/**
 * Single map
 */
class Map {
public:
    Map();
    QString name;
    virtual void loadMap(GameControl* gc);

    QString getName() {
        return name;
    }
};

class Map1 : public Map {
public:
    Map1();
    void loadMap(GameControl* gc);
};

class Map2 : public Map {
public:
    Map2();
    void loadMap(GameControl* gc);
};
#endif // MAPS_H
