/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "playerportrait.h"
#include "ui_playerportrait.h"

PlayerPortrait::PlayerPortrait(QWidget *parent) :
QWidget(parent),
ui(new Ui::PlayerPortrait) {
    ui->setupUi(this);
}

PlayerPortrait::~PlayerPortrait() {
    delete ui;
}

void PlayerPortrait::setHP(int hp) {
    ui->HPBar->setValue(hp);
}

void PlayerPortrait::setShield(int s) {
    ui->SBar->setValue(s);
}

void PlayerPortrait::setAmmo(int ammo, int ammoMax) {
    ui->AmmoBar->setMaximum(ammoMax);
    ui->AmmoBar->setValue(ammo);
}

void PlayerPortrait::setAmmo(int ammo) {
    ui->AmmoBar->setValue(ammo);
}

void PlayerPortrait::setName(QString name) {
    ui->label->setText(name);
}

void PlayerPortrait::setScore(int score) {
    ui->label_3->setText(QString::number(score));
}
