/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#include "projectile.h"
#include "iostream"

Projectile::Projectile() : GameObject() {
}

void Projectile::update(int elapsed) {
    GameObject::update(elapsed);
    duration -= elapsed;
}

Bullet::Bullet() {
    type = BULLET;
    maxSpeed = 1;
    duration = 750;
    dmg = 200;
    collisionRadius = 0.5;
    projectSpeed = 0.15;

    osg::Sphere* koule = new osg::Sphere(osg::Vec3(0, 0, 0), 0.5);
    osg::ShapeDrawable* drawable = new osg::ShapeDrawable(koule);
    drawable->setColor(osg::Vec4(0, 1, 0, 1));
    osg::Geode* geo = new osg::Geode;
    geo->addDrawable(drawable);
    model->addChild(geo);
}

Beam::Beam(osg::Vec3 a, osg::Vec3 b) {
    collisionImmune = true;
    type = BEAM;
    maxSpeed = 1;
    duration = 50;
    dmg = 100;
    collisionRadius = 0;
    projectSpeed = 0;
    osg::Geode* geode = new osg::Geode;
    osg::Geometry* geom = new osg::Geometry;

    osg::Vec3Array* vertices = new osg::Vec3Array(2);
    osg::Vec3Array::iterator vitr = vertices->begin();
    (vitr++)->set(a);
    (vitr++)->set(b);
    geom->setVertexArray(vertices);

    osg::Vec4Array* colors = new osg::Vec4Array;
    colors->push_back(osg::Vec4(0.0f, 1.0f, 0.0f, 1.0f));

    geom->setColorArray(colors);
    geom->setColorBinding(osg::Geometry::BIND_OVERALL);

    osg::Vec3Array* normals = new osg::Vec3Array;
    normals->push_back(osg::Vec3(0.0f, 0.0f, 1.0f));
    geom->setNormalArray(normals);
    geom->setNormalBinding(osg::Geometry::BIND_OVERALL);

    osg::LineWidth* linewidth = new osg::LineWidth();
    linewidth->setWidth(4.0f);
    geom->getOrCreateStateSet()->setAttributeAndModes(linewidth, osg::StateAttribute::ON);

    geom->addPrimitiveSet(new osg::DrawArrays(osg::PrimitiveSet::LINES, 0, 2));
    geode->addDrawable(geom);

    model->addChild(geode);
}
