/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef PROJEKTILE_H
#define PROJEKTILE_H

#include "gameobject.h"

#include <osg/ShapeDrawable>
#include <osg/LineWidth>

/**
 * Abstract class for projectiles, extends game object
 */
class Projectile : public GameObject {
public:

    enum projectileType {
        BULLET, BEAM
    };

    Projectile();

    virtual void update(int elapsed);

    bool isExpired() {
        return duration <= 0;
    }

    void setExpired() {
        duration = 0;
    }

    int getDamage() {
        return dmg;
    }

    GameObject* getOwner() {
        return owner;
    }

    char getType() {
        return type;
    }

    void setOwner(GameObject* o) {
        owner = o;
    }

    double getProjectSpeed() {
        return projectSpeed;
    }
protected:
    int duration;
    int dmg;
    double projectSpeed;
    GameObject* owner;
    char type;
};

class Bullet : public Projectile {
public:
    Bullet();
};

class Beam : public Projectile {
public:
    Beam(osg::Vec3 a, osg::Vec3 b);
};

#endif // GOPROJEKTILE_H
