/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#include "weapon.h"

Weapon::Weapon() {
    twoShot = false;
    weaponCdRemaining = 0;
}

void Weapon::update(int elapsed) {
    if (weaponCdRemaining > 0) weaponCdRemaining -= elapsed;
    if (ammo == 0) {
        if (reloadTimeRemaining <= 0) {
            ammo = ammoMax;
            reloadTimeRemaining = reloadTime;
        } else {
            reloadTimeRemaining -= elapsed;
        }
    }
}

bool Weapon::isReady() {
    return ammo > 0 && weaponCdRemaining <= 0;
}

void Weapon::shoot() {
    ammo--;
    weaponCdRemaining = weaponCd;
    if(ammo<0)ammo=0;
}

Projectile* Weapon::newProjectile() {
    return new Projectile;
}

Chaingun::Chaingun() : Weapon() {
    weaponCd = 150;
    ammoMax = 20;
    ammo = ammoMax;

    reloadTime = 2000;
    reloadTimeRemaining = reloadTime;
    twoShot = true;

    type=CHAINGUN;
}

Projectile* Chaingun::newProjectile() {
    return new Bullet;
}


Laser::Laser() : Weapon() {
    weaponCd = 40;
    ammoMax = 400;
    ammo = ammoMax;

    reloadTime = 999999;
    reloadTimeRemaining = reloadTime;
    twoShot = true;

    type=LASER;
}

Projectile* Laser::newProjectile() {
    return new Bullet;
}
