/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#include "gswidget.h"

GSWidget::GSWidget(QWidget *parent) :
QWidget(parent) {

    // create and setup GL widget
    gw = new QGraphicsView(this);

    QGLFormat glFormat(QGL::SampleBuffers);
    glFormat.setSwapInterval(Settings::instance()->vsync ? 1 : 0); // Vsync

    gw->setViewport(new QGLWidget(glFormat));
    gw->setViewportUpdateMode(QGraphicsView::FullViewportUpdate);


    gw->setGeometry(0, 0, width(), height());
    gw->setParent(this);
}

GSWidget::~GSWidget() {
    std::cout << "GSWidget destruktor\n";
    delete gw;
    std::cout << "GSWidget destruktor end\n";
}

void GSWidget::resizeEvent(QResizeEvent *event) {
    std::cout << "GSWidget resizeEvent\n";
    gw->resize(event->size());
    scene->setSceneRect(0, 0, event->size().width() - 5, event->size().height() - 5);
    scene->resize(event->size());
    std::cout << "GSWidget resizeEvent end\n";
}
