/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#ifndef GSWIDGET_H
#define GSWIDGET_H

#include <QWidget>
#include <QGraphicsView>
#include <QResizeEvent>

#include "qosgscene.h"
#include "settings.h"

/**
 * Class to wrap up 3D scene with other widgets
 * @see gamecontrolwidget
 * @see menuwidget
 */
class GSWidget : public QWidget {
    Q_OBJECT
public:
    explicit GSWidget(QWidget *parent = 0);
    virtual ~GSWidget();

protected:
    QGraphicsView* gw;
    QOSGScene* scene;
    virtual void resizeEvent(QResizeEvent *event);
signals:

public slots:

};

#endif // GSWIDGET_H
