/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#ifndef LAUNCHER_H
#define LAUNCHER_H
class Launcher;
#include <QMainWindow>

#include "menu/menuwidget.h"
#include "menu/loadwidget.h"
#include "menu/creditswidget.h"

#include "game/gamecontrolwidget.h"

/**
 * Main window widget, manages switching between menus and game
 */
class Launcher : public QMainWindow {
    Q_OBJECT
public:
    explicit Launcher(QWidget *parent = 0);
    virtual ~Launcher();

    void resizeEvent(QResizeEvent *event);

    void keyPressEvent(QKeyEvent *evt);

    void escape();
    static Launcher* instance();

    bool ignoreControls;
private:
    static Launcher* pinstance;
    //QWidget* currentWidget;
    MenuWidget* menu;
    LoadWidget* loader;
    GameControlWidget* gcw;
    CreditsWidget* cw;

    QWidget* background;
    bool fullscreen;

    void switchFullScreen();

signals:

public slots:
    void Load();
    void Menu();
    void QuickGame();
    void HotSeatGame();
    void HostGame();
    void clientGame();
    void Quit();
    void Restart();
    void credits();

    void GameOver();
};

#endif // LAUNCHER_H
