/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "creditsscene.h"

CreditsScene::CreditsScene(QObject *parent) :
QOSGScene(parent) {
    osg::Group* root = new osg::Group;
    texts = new osg::PositionAttitudeTransform;

    osgText::Font* font = osgText::readFontFile("data/font.ttf");
    osgText::Text3D* text3D = new osgText::Text3D;
    text3D->setFont(font);

    osgText::Style* style = new osgText::Style;
    style->setThicknessRatio(0.08f);
    text3D->setStyle(style);
    text3D->setCharacterSize(1.7);
    text3D->setDrawMode(osgText::Text3D::TEXT);
    text3D->setAxisAlignment(osgText::Text3D::XZ_PLANE);
    text3D->setText("Kolaborativni interakce mezi uzivately\n\n"
            "ve virtualni 3D scene\n\n\n\n\n"
            "   ---== KIMU the Game ==---\n\n\n\n\n"
            "Tato hra vznikla jako bakalarska prace\n\n"
            "na Fakulte informacnich technologi\n\n"
            "Vysokecho uceni technickeho v Brne\n\n\n\n\n\n\n\n\n\n"
            "Autor\n\n"
            "--=A=--\n\n"
            "Michal Toth\n\n\n\n\n\n\n\n\n\n"
            "Vedouci prace\n\n"
            "--=V=--\n\n"
            "Ing. Jan Peciva, Ph.D.\n\n\n\n\n\n\n\n\n\n"
            "\n\n\n\n\n\n\n\n\n\n"
            "\n\n\n\n\n\n\n\n\n\n"
            "\n\n\n\n\n\n\n\n\n\n"

            "Collaborative Interaction among Users\n\n"
            "in Virtual 3D Scene\n\n\n\n\n"
            "   ---== KIMU the Game ==---\n\n\n\n\n"
            "This game was created as bechelor thesis\n\n"
            "on Faculty of Information Technology\n\n"
            "Brno University of Technology\n\n\n\n\n"
            "Author\n\n"
            "--=A=--\n\n"
            "Michal Toth\n\n\n\n\n\n\n\n\n\n"
            "Supervisor\n\n"
            "--=S=--\n\n"
            "Ing. Jan Peciva, Ph.D.\n\n\n\n\n\n\n\n\n\n"
            );
    osg::Vec4 color(1.0f, 1.0f, 0.0f, 1.0f);
    text3D->setColor(color);
    text3D->setAlignment(osgText::Text3D::CENTER_TOP);

    osg::Geode* geode = new osg::Geode;
    geode->addDrawable(text3D);

    texts->addChild(geode);


    root->addChild(texts);

    fixedCamera();


    osg::Node* sp = ModelLoader::instance()->modelSpace.get();
    osg::PositionAttitudeTransform* tx = new osg::PositionAttitudeTransform;
    //tx->setScale(osg::Vec3(10,10,10));
    tx->setAttitude(osg::Quat(+osg::PI_4, osg::Vec3(0, 1.0, 0)));
    tx->addChild(sp);
    root->addChild(tx);



    lab = new QLabel;
    BigButton* pb = new BigButton(lab);
    pb->setText(Texts::get(QString("BACK")));
    pb->setGeometry(0, 0, 80, 40);
    pb->show();
    connect(pb, SIGNAL(clicked()), this, SLOT(slotBack()));

    addWidget(lab);
    lab->setGeometry(width() - 100, height() - 100, 100, 60);
    lab->show();

    connect(this, SIGNAL(resized()), this, SLOT(resized()));

    timer.start(10);
    connect(&timer, SIGNAL(timeout()), this, SLOT(scroll()));
    time.start();
    z = -30;

    scroll();


    setSceneData(root);
}

CreditsScene::~CreditsScene() {
}

void CreditsScene::slotBack() {
    emit back();
}

void CreditsScene::resized() {
    lab->setGeometry(width() - 100, height() - 60, 80, 40);
}

void CreditsScene::scroll() {
    z += time.elapsed()*0.002;
    time.restart();
    texts->setPosition(osg::Vec3(0, 0, z));

    if (z > 200) emit back();
}
