/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/


#include "menugamechooser.h"
#include "ui_menugamechooser.h"

#include <iostream>

MenuGameChooser::MenuGameChooser(QLabel *parent) :
QLabel(parent),
ui(new Ui::MenuGameChooser) {
    ui->setupUi(this);
    set = Settings::instance();

    ui->checkBox->setText(Texts::get(ui->checkBox->text()));
    ui->checkBox_2->setText(Texts::get(ui->checkBox_2->text()));
    ui->checkBox_3->setText(Texts::get(ui->checkBox_3->text()));

    ui->pushButton->setText(Texts::get(ui->pushButton->text()));
    ui->pushButton_2->setText(Texts::get(ui->pushButton_2->text()));
    ui->label->setText(Texts::get(ui->label->text()));
    ui->label_2->setText(Texts::get(ui->label_2->text()));

    ports[0] = ui->p1_port;
    ports[1] = ui->p2_port;
    ports[2] = ui->p3_port;
    ports[3] = ui->p4_port;

    ui->p1_port->setPixmap(set->getPlayerIcon(1));
    ui->p2_port->setPixmap(set->getPlayerIcon(2));
    ui->p3_port->setPixmap(set->getPlayerIcon(0));
    ui->p4_port->setPixmap(set->getPlayerIcon(0));

    playerTypes[0] = 1;
    playerTypes[1] = 2;
    playerTypes[2] = 0;
    playerTypes[3] = 0;

    QVector<Map*> *mapList = Maps::instance()->getMapList();
    for (int i = 0; i < mapList->count(); i++) {
        new QListWidgetItem(mapList->at(i)->getName(), ui->listWidget, 1000 + i);
    }
    ui->listWidget->item(0)->setSelected(true);
    solo = false;


}

MenuGameChooser::~MenuGameChooser() {
    delete ui;
}

void MenuGameChooser::setSolo() {
    solo = true;
    ui->lineEdit_2->setText("Skynet");
    ui->lineEdit_2->setText("EDI");
    ui->lineEdit_2->setText("Legion");
}

void MenuGameChooser::on_pushButton_clicked() {
    // start
    for (int i = 0; i < MAX_PLAYERS; i++) {
        set->playerType[i] = playerTypes[i];
    }
    set->setPlayerName(0, ui->lineEdit->text());
    set->setPlayerName(1, ui->lineEdit_2->text());
    set->setPlayerName(2, ui->lineEdit_3->text());
    set->setPlayerName(3, ui->lineEdit_4->text());

    if (ui->listWidget->selectedItems().count() != 1) return;
    set->setSelectedMap(ui->listWidget->selectedItems().at(0)->type() - 1000);

    set->modeDmg = ui->checkBox->isChecked();
    set->modeAmmo = ui->checkBox_2->isChecked();
    set->modeNoBonus = ui->checkBox_3->isChecked();

    set->score = ui->spinBox->value();

    set->solo = solo;
    emit start();
}

void MenuGameChooser::on_pushButton_2_clicked() {
    //back
    emit back();
}

void MenuGameChooser::on_p1_left_clicked() {
    prev(0);
}

void MenuGameChooser::on_p1_right_clicked() {
    next(0);
}

void MenuGameChooser::on_p2_left_clicked() {
    prev(1);
}

void MenuGameChooser::on_p2_right_clicked() {
    next(1);
}

void MenuGameChooser::on_p3_left_clicked() {
    prev(2);
}

void MenuGameChooser::on_p3_right_clicked() {
    next(2);
}

void MenuGameChooser::on_p4_left_clicked() {
    prev(3);
}

void MenuGameChooser::on_p4_right_clicked() {
    next(3);
}

void MenuGameChooser::next(int i) {
    if (playerTypes[i] == MAX_PLAYER_TYPE) {
        playerTypes[i] = 0;
    } else {
        (playerTypes[i])++;
    }
    ports[i]->setPixmap(set->getPlayerIcon(playerTypes[i]));
}

void MenuGameChooser::prev(int i) {
    if (playerTypes[i] == 0) {
        playerTypes[i] = MAX_PLAYER_TYPE;
    } else {
        playerTypes[i]--;
    }
    ports[i]->setPixmap(set->getPlayerIcon(playerTypes[i]));
}
