/*****************************************************************************
 * ISP/IBP 2011/2012
 * Author: Michal Toth (xtothm00@stud.fit.vutbr.cz)
 *
 *****************************************************************************/

#ifndef MENUGAMECHOOSER_H
#define MENUGAMECHOOSER_H

#include <QLabel>

#include "../texts.h"
#include "../settings.h"
#include "../game/maps.h"

#include "dragable.h"

namespace Ui {
    class MenuGameChooser;
}

/**
 * Hot seat game menu chooser
 */
class MenuGameChooser : public QLabel {
    Q_OBJECT

public:
    explicit MenuGameChooser(QLabel *parent = 0);
    ~MenuGameChooser();

    void setSolo();

private:
    DRAGABLE
    Ui::MenuGameChooser *ui;
    Settings* set;
    int playerTypes[MAX_PLAYERS];
    QLabel* ports[MAX_PLAYERS];


    void next(int i);
    void prev(int i);

    bool solo;

signals:
    void start();
    void back();
private slots:
    void on_pushButton_clicked();
    void on_pushButton_2_clicked();


    void on_p1_left_clicked();
    void on_p1_right_clicked();
    void on_p2_left_clicked();
    void on_p2_right_clicked();
    void on_p3_left_clicked();
    void on_p3_right_clicked();
    void on_p4_left_clicked();
    void on_p4_right_clicked();
};

#endif // MENUGAMECHOOSER_H
