/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef MENUGAMECHOOSERMP_H
#define MENUGAMECHOOSERMP_H

#include <QLabel>
#include <QTcpServer>

#include "../texts.h"
#include "../settings.h"
#include "../game/maps.h"

#include "../network/hostconnection.h"
#include "../network/packet.h"
#include "../network/connection.h"

#include "dragable.h"

namespace Ui {
    class MenuGameChooserMP;
}

class MenuGameChooserMP : public QLabel {
    Q_OBJECT

public:
    explicit MenuGameChooserMP(QLabel *parent = 0);
    ~MenuGameChooserMP();

    void hosted(HostConnection* hostcon);
    void joined(Connection* con);

    bool isHost() {
        return host;
    }


private:
    DRAGABLE
    Ui::MenuGameChooserMP *ui;
    Settings* set;
    int playerTypes[MAX_PLAYERS];
    QLabel* ports[MAX_PLAYERS];


    HostConnection* hostcon;
    Connection* con;

    bool host;
    int playerNumber;
    bool ignorePackets;

    void next(int i);
    void prev(int i);


    void assignedNumber(IntPacket *p);
    void modelSelect(IntPacket *p);
    void nameSelect(ChatPacket *p);
    void chooserState(ChooserPacket *p);

    void setModel(int m, int p);

    void packetDisconnected(IntPacket* p);

signals:
    void start();
    void leave();
    void dc();

public slots:
    void slotNewClient();
    void slotPacketReady();
    void sendChooserState();
    void sendName(QString);

private slots:
    void on_pChatSend_clicked();
    void on_p4_right_clicked();
    void on_p1_left_clicked();
    void on_p1_right_clicked();
    void on_p2_left_clicked();
    void on_p2_right_clicked();
    void on_p3_left_clicked();
    void on_p3_right_clicked();
    void on_p4_left_clicked();
    void on_pBack_clicked();
    void on_pStart_clicked();
};

#endif // MENUGAMECHOOSERMP_H
