/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "menuoptions.h"
#include "ui_menuoptions.h"

MenuOptions::MenuOptions(QWidget *parent) :
QLabel(parent),
ui(new Ui::MenuOptions) {
    ui->setupUi(this);

    ui->groupBox->setTitle(Texts::get(ui->groupBox->title()));
    ui->groupBox_2->setTitle(Texts::get(ui->groupBox_2->title()));
    ui->groupBox_3->setTitle(Texts::get(ui->groupBox_3->title()));

    ui->checkBox->setText(Texts::get(ui->checkBox->text()));
    ui->checkBox_2->setText(Texts::get(ui->checkBox_2->text()));
    ui->checkBox_3->setText(Texts::get(ui->checkBox_3->text()));
    ui->checkBox_4->setText(Texts::get(ui->checkBox_4->text()));




    QButtonGroup* bg = new QButtonGroup(this);
    bg->addButton(ui->rbLangCZ);
    bg->addButton(ui->rbLangEN);

    QIcon iconCZ(QString("data/flagCZ.png"));
    ui->rbLangCZ->setIcon(iconCZ);

    QIcon iconEN(QString("data/flagEN.png"));
    ui->rbLangEN->setIcon(iconEN);

    Settings* set = Settings::instance();
    switch (set->lang) {
        case Settings::enGB:
            ui->rbLangEN->setChecked(true);
            break;
        case Settings::czCZ:
            ui->rbLangCZ->setChecked(true);
            break;
    }

    ui->cbVsync->setChecked(set->vsync);
    ui->checkBox->setChecked(set->particles);
    ui->checkBox_2->setChecked(set->plUi3D);
    ui->checkBox_3->setChecked(set->debug);
    ui->checkBox_4->setChecked(set->plUi2D);
}

MenuOptions::~MenuOptions() {
    delete ui;
}

void MenuOptions::on_pOK_clicked() {
    // save settings
    Settings* set = Settings::instance();
    if (ui->rbLangCZ->isChecked())
        set->lang = Settings::czCZ;
    if (ui->rbLangEN->isChecked())
        set->lang = Settings::enGB;
    set->vsync = ui->cbVsync->isChecked();

    set->plUi2D = ui->checkBox_4->isChecked();
    set->plUi3D = ui->checkBox_2->isChecked();
    set->debug = ui->checkBox_3->isChecked();
    set->particles = ui->checkBox->isChecked();

    set->save();
    emit ok();
}

void MenuOptions::on_pSTORNO_clicked() {
    // storno
    emit back();
}
