/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#ifndef MENUSCENE_H
#define MENUSCENE_H

#include "../qosgscene.h"
#include "../modelloader.h"

#include "menu.h"
#include "menugamechooser.h"
#include "menuconnect.h"
#include "menugamechoosermp.h"
#include "menuoptions.h"
#include "help.h"
#include "scorescreen.h"

#include "../network/hostconnection.h"
#include "../network/connection.h"
#include "../network/packet.h"

#include "../gfx/enginesmoke.h"

#include <QLabel>
#include <QTcpServer>
#include <QMessageBox>

/**
 * Class to wrap menu widgets and 3D menu scene
 */
class MenuScene : public QOSGScene {
    Q_OBJECT
public:
    explicit MenuScene(QObject *parent = 0);
    virtual ~MenuScene();

protected:
    Menu* menu;
    MenuGameChooser* menugc;
    MenuGameChooserMP* menugcmp;
    MenuConnect* menuConnect;
    MenuOptions* menuOptions;
    Help* help;

    void deleteAll();
signals:
    void QuickGame();
    void HotSeatGame();
    void HostGame();
    void ClientGame();
    void restart();
    void Credits();



public slots:
    void slotHelp();
    void slotHelpBack();

    void slotHotSeat();
    void slotQuickGame();
    void slotMultiplayer();
    void slotDc();
    void slotOptions();
    void slotOptionsOK();

    void slotHost(QString ip, int port);
    void slotJoin(QString ip, int port);
    void slotStart();

    void slotCredits();
    void slotSolo();
    void slotGameOver();
};

#endif // MENUSCENE_H
