/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#include "modelloader.h"


ModelLoader* ModelLoader::pinstance=NULL;

ModelLoader::ModelLoader(QObject *parent) :
    QObject(parent)
{
}


ModelLoader *ModelLoader::instance(){
    if(!pinstance){
        pinstance = new ModelLoader;
    }
    return pinstance;
}

void ModelLoader::load(){
    //printf("ModelLoader load");
    emit progress(0);
    modelBonusHeal = osgDB::readNodeFile("data/bonusHeal.obj");
    emit progress(5);
    modelSputnik = osgDB::readNodeFile("data/sputnik.obj");
    emit progress(10);
    modelBonusAmmo = osgDB::readNodeFile("data/bonusAmmo.obj");
    emit progress(15);

    emit progress(20);
    modelRaider = osgDB::readNodeFile("data/raider.obj");
    emit progress(30);
    modelWraith = osgDB::readNodeFile("data/wraith.obj");
    emit progress(40);
    modelSpace = osgDB::readNodeFile("data/space.obj");
    emit progress(50);
    modelSpace2 = osgDB::readNodeFile("data/space2.obj");

    emit progress(60);

    modelAsteroid = osgDB::readNodeFile("data/asteroid.obj");
    emit progress(70);
    modelPlanet = osgDB::readNodeFile("data/planet.obj");
    emit progress(80);
    modelMoon = osgDB::readNodeFile("data/moon.obj");
    emit progress(85);
    modelAsteroidField = osgDB::readNodeFile("data/asteroidField.obj");
    emit progress(90);

    modelBonusLaser = osgDB::readNodeFile("data/bonusLaser.obj");
    emit progress(99);
    //printf("ModelLoader load end");
    emit progress(100);
}

void ModelLoader::reload(){
    modelBonusLaser = osgDB::readNodeFile("data/bonusLaser.obj");
    modelBonusHeal = osgDB::readNodeFile("data/bonusHeal.obj");
    modelBonusAmmo = osgDB::readNodeFile("data/bonusAmmo.obj");
}
