/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/


#ifndef MODELLOADER_H
#define MODELLOADER_H

#include <QObject>

#include <osg/Node>
#include <osgDB/ReadFile>

class ModelLoader : public QObject
{
    Q_OBJECT
public:
    static ModelLoader* pinstance;
    static ModelLoader* instance();

    void load();
    void reload();


    osg::ref_ptr<osg::Node> modelBonusHeal;
    osg::ref_ptr<osg::Node> modelBonusAmmo;
    osg::ref_ptr<osg::Node> modelBonusLaser;

    osg::ref_ptr<osg::Node> modelRaider;
    osg::ref_ptr<osg::Node> modelWraith;
    osg::ref_ptr<osg::Node> modelSputnik;

    osg::ref_ptr<osg::Node> modelSpace;
    osg::ref_ptr<osg::Node> modelSpace2;

    osg::ref_ptr<osg::Node> modelAsteroid;
    osg::ref_ptr<osg::Node> modelPlanet;
    osg::ref_ptr<osg::Node> modelMoon;
    osg::ref_ptr<osg::Node> modelAsteroidField;

private:
    explicit ModelLoader(QObject *parent = 0);
    
signals:
    void progress(int);
public slots:
    
};

#endif // MODELLOADER_H
