/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/
#ifndef HOSTCONNECTION_H
#define HOSTCONNECTION_H

#include <QObject>
#include <QTcpServer>

#include "connection.h"
#include "packet.h"
#include "clientinfo.h"

/**
 * Host connection, handles making new connections
 * and communcation with multiple clients
 * @see Connection
 */
class HostConnection : public Connection {
    Q_OBJECT
public:
    explicit HostConnection(QObject *parent = 0);
    virtual ~HostConnection();
    QString* init(int port);

    virtual void sendFast(Packet *p);
    virtual void send(Packet *p);

protected:
    QVector<QTcpSocket*> clientSocketsTCP;
    QVector<ClientInfo> clients;
    QTcpServer* serverTCP;
    virtual void readUDP(QUdpSocket*);
    int getFreeNumber();


signals:

public slots:
    void slotNewClient();
    void slotTCPReady();
    void slotUDPReady();
    virtual void disconnected();

};

#endif // HOSTCONNECTION_H
