/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/


#include "texts.h"
#include <iostream>
#include <string>


Texts* Texts::pinstance = NULL;

Texts::Texts() {
    std::cout << "Texts constructor\n";
    map = new QMap<QString, QString>;
    update();
    std::cout << "Texts constructor end\n";
}

Texts* Texts::instance() {
    if (pinstance == NULL) {
        pinstance = new Texts();
    }
    return pinstance;
}

QString Texts::get(QString text) {
    if (instance()->map->contains(text)) {
        return instance()->map->value(text);
    } else {
        return text;
    }
}

void Texts::update() {
    map->clear();
    Settings::language l = Settings::instance()->lang;
    QString name = Settings::instance()->langPath;
    switch (l) {
        case Settings::czCZ:
            name += QString("czCZ");
            break;
        case Settings::enGB:
            name += QString("enGB");
            break;
    }
    QFile file(name);
    file.open(QFile::ReadOnly);

    char buf[1024];
    while (file.readLine(buf, sizeof (buf)) != -1) {
        QString line(buf);
        line.replace(QString("\n"), QString(""));
        line.replace(QString("\r"), QString(""));
        if (line.length() > 0 && line.at(0) != '#')
            map->insert(line.section('=', 0, 0), line.section('=', 1, 1));
    }

}
