/*****************************************************************************\
 *
 * Author: Michal Tth (xtothm00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/


#ifndef TEXTS_H
#define TEXTS_H

#include <QString>
#include <QMap>
#include <QFile>

#include "settings.h"

/**
 * Class for translating texts
 */

#define tt(a) Texts::get(a)
#define ttb(a) a->setText(Texts::get(a->text()))

class Texts {
public:

    static Texts* instance();
    static QString get(QString text);
private:
    Texts();
    static Texts* pinstance;

    QMap<QString, QString>* map;

    public
slots:
    /**
     * Reload language file
     */
    void update();
};

#endif // TEXTS_H
